Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3322)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3337)
@@ -5320,4 +5481,5 @@
                            naheatlayers,                                       &
                            pedestrian_category,                                &
+                           roughness_concrete,                                 &
                            read_wall_temp_3d,                                  &
                            roof_category,                                      &
@@ -5337,4 +5499,5 @@
                            naheatlayers,                                       &
                            pedestrian_category,                                &
+                           roughness_concrete,                                 &
                            read_wall_temp_3d,                                  &
                            roof_category,                                      &
@@ -6937,8 +7100,25 @@
            ENDDO
            IF ( ip == -99999 )  THEN
-!--           wall category not found
-              WRITE (message_string, "(A,I5,A,3I5)") 'wall category ', it,     &
-                                     ' not found  for i,j,k=', iw,jw,kw
-              CALL message( 'usm_read_urban_surface', 'PA0506', 1, 2, 0, 6, 0 )
+!--           land/roof category not found
+              WRITE (9,"(A,I5,A,3I5)") 'land/roof category ', it,     &
+                                       ' not found  for i,j,k=', iw,jw,kw
+              FLUSH(9)
+              IF ( surf_usm_h%isroof_surf(m) ) THEN
+                 category = roof_category
+              ELSE
+                 category = land_category
+              ENDIF
+              DO k = 1, n_surface_types
+                 IF ( surface_type_codes(k) == roof_category ) THEN
+                    ip = k
+                    EXIT
+                 ENDIF
+              ENDDO
+              IF ( ip == -99999 )  THEN
+!--              default land/roof category not found
+                 WRITE (9,"(A,I5,A,3I5)") 'Default land/roof category', category, ' not found!'
+                 FLUSH(9)
+                 ip = 1
+              ENDIF
            ENDIF
 !
@@ -7036,4 +7216,7 @@
                  surf_usm_v(l)%albedo(:,m)    = -1.0_wp
                  surf_usm_v(l)%thickness_wall(m) = -1.0_wp
+                 surf_usm_v(l)%thickness_window(m)   = -1.0_wp
+                 surf_usm_v(l)%thickness_green(m)    = -1.0_wp
+                 surf_usm_v(l)%transmissivity(m)  = -1.0_wp
               ELSE IF ( kw <= usm_par(ii,jw,iw) )  THEN
 !--                 pedestrian zone
@@ -7089,4 +7272,12 @@
               ELSE
 !
+                 WRITE(9,*) 'Problem reading USM data:'
+                 WRITE(9,*) l,i,j,kw,get_topography_top_index_ji( j, i, 's' )
+                 WRITE(9,*) ii,iw,jw,kw,get_topography_top_index_ji( jw, iw, 's' )
+                 WRITE(9,*) usm_par(ii,jw,iw),usm_par(ii+1,jw,iw)
+                 WRITE(9,*) usm_par(ii+2,jw,iw),usm_par(ii+3,jw,iw)
+                 WRITE(9,*) usm_par(ii+4,jw,iw),usm_par(ii+5,jw,iw)
+                 WRITE(9,*) kw,roof_height_limit,wall_category,roof_category
+                 FLUSH(9)
 !--              supply the default category
                  IF ( kw <= roof_height_limit ) THEN
@@ -7097,4 +7288,7 @@
                  surf_usm_v(l)%albedo(:,m)    = -1.0_wp
                  surf_usm_v(l)%thickness_wall(m) = -1.0_wp
+                 surf_usm_v(l)%thickness_window(m) = -1.0_wp
+                 surf_usm_v(l)%thickness_green(m) = -1.0_wp
+                 surf_usm_v(l)%transmissivity(m)  = -1.0_wp
               ENDIF
 !
@@ -7110,8 +7304,22 @@
               IF ( ip == -99999 )  THEN
 !--              wall category not found
-                 WRITE (message_string, "(A,I7,A,3I5)") 'wall category ', it,  &
-                                        ' not found  for i,j,k=', iw,jw,kw
-                 WRITE(9,*) message_string
+                 WRITE (9, "(A,I7,A,3I5)") 'wall category ', it,  &
+                                           ' not found  for i,j,k=', iw,jw,kw
+                 FLUSH(9)
+                 category = wall_category 
+                 DO k = 1, n_surface_types
+                    IF ( surface_type_codes(k) == category ) THEN
+                       ip = k
+                       EXIT
+                    ENDIF
+                 ENDDO
+                 IF ( ip == -99999 )  THEN
+!--                 default wall category not found
+                    WRITE (9, "(A,I5,A,3I5)") 'Default wall category', category, ' not found!'
+                    FLUSH(9)
+                    ip = 1
+                 ENDIF
               ENDIF
+
 !
 !--           Albedo
@@ -7192,4 +7400,8 @@
         ENDDO
 
+        
+        WRITE(9,*) 'Urban surfaces read'
+        FLUSH(9)
+        
         CALL location_message( '    types and parameters of urban surfaces read', .TRUE. )
    
@@ -7473,5 +7685,5 @@
            IF ( humidity )  surf_usm_h%vpt_surface(m) =                        &
                                                    surf_usm_h%pt_surface(m)
-                       
+
 !--        calculate true tendency
            stend = ( t_surf_h_p(m) - t_surf_h(m) - dt_3d * tsc(3) *           &
@@ -7508,5 +7720,5 @@
 !
 !--        calculate fluxes
-!--        rad_net_l is never used!           
+!--        rad_net_l is never used!
            surf_usm_h%rad_net_l(m) = surf_usm_h%rad_net_l(m) +                           &
                                      surf_usm_h%frac(ind_veg_wall,m) *                   &
@@ -7522,7 +7734,7 @@
            surf_usm_h%wghf_eb(m)   = lambda_surface *                         &
                                       ( t_surf_h_p(m) - t_wall_h(nzb_wall,m) )
-           surf_usm_h%wghf_eb_green(m)  = lambda_surface_green *                        &
+           surf_usm_h%wghf_eb_green(m)  = lambda_surface_green *                         &
                                           ( t_surf_green_h_p(m) - t_green_h(nzb_wall,m) )
-           surf_usm_h%wghf_eb_window(m) = lambda_surface_window *                       &
+           surf_usm_h%wghf_eb_window(m) = lambda_surface_window *                        &
                                            ( t_surf_window_h_p(m) - t_window_h(nzb_wall,m) )
 
@@ -7539,5 +7751,5 @@
 !--        diffusion_s, surface_layer_fluxes,...
            surf_usm_h%shf(m) = surf_usm_h%wshf_eb(m) / c_p
-
+      
        ENDDO
 !
@@ -7562,5 +7774,5 @@
 #if ! defined( __nopointer )          
 !
-!--          calculate rho * c_p coefficient at surface layer
+!--          calculate rho * c_p coefficient at wall layer
              rho_cp  = c_p * hyp(k) / ( r_d * surf_usm_v(l)%pt1(m) * exner(k) )
 #endif
@@ -7589,8 +7801,8 @@
 !--          obtained by simple linear interpolation. ( An alternative would
 !--          be an logarithmic interpolation. )
-!--          A roughness lenght of 0.001 is assumed for concrete (the inverse,
-!--          1000 is used in the nominator for scaling)
-             surf_usm_v(l)%r_a(m) = rho_cp / ( surf_usm_v(l)%z0(m) * 1000.0_wp &
-                        * ( 11.8_wp + 4.2_wp *                                 &
+!--          Parameter roughness_concrete (default value = 0.001) is used
+!--          to calculation of roughness relative to concrete
+             surf_usm_v(l)%r_a(m) = rho_cp / ( surf_usm_v(l)%z0(m) /           &
+                        roughness_concrete * ( 11.8_wp + 4.2_wp *              &
                         SQRT( MAX( ( ( u(k,j,i) + u(k,j,i+1) ) * 0.5_wp )**2 + &
                                    ( ( v(k,j,i) + v(k,j+1,i) ) * 0.5_wp )**2 + &
@@ -7606,6 +7818,4 @@
              f_shf_window  = rho_cp / surf_usm_v(l)%r_a(m)
              f_shf_green   = rho_cp / surf_usm_v(l)%r_a(m)
-
-
 
 !--          add LW up so that it can be removed in prognostic equation
@@ -7657,6 +7867,4 @@
                            ( surf_usm_v(l)%c_surface_green(m) + coef_green_2 * dt_3d * tsc(2) ) 
 
-
-
 !--           add RK3 term
               t_surf_v_p(l)%t(m) = t_surf_v_p(l)%t(m) + dt_3d * tsc(3) *       &
@@ -7677,5 +7885,5 @@
               IF ( humidity )  surf_usm_v(l)%vpt_surface(m) =                  &
                                                     surf_usm_v(l)%pt_surface(m)
-            
+
 !--           calculate true tendency
               stend = ( t_surf_v_p(l)%t(m) - t_surf_v(l)%t(m) - dt_3d * tsc(3) *&
@@ -7766,20 +7974,21 @@
            dtime = mod(simulated_time + time_utc_init, 24.0_wp*3600.0_wp)
            dhour = INT(dtime/3600.0_wp)
-           DO m = 1, naheatlayers
-!--           Get indices of respective grid point
-              i = surf_usm_h%i(m)
-              j = surf_usm_h%j(m)
-              k = surf_usm_h%k(m)
-              IF ( k > get_topography_top_index_ji( j, i, 's' )  .AND. &
-                   k <= naheatlayers )  THEN
-!--              increase of pt in box i,j,k in time dt_3d 
-!--              given to anthropogenic heat aheat*acoef (W*m-2)
-!--              linear interpolation of coeficient
-                 acoef = (REAL(dhour+1,wp)-dtime/3600.0_wp)*aheatprof(k,dhour) + &
-                         (dtime/3600.0_wp-REAL(dhour,wp))*aheatprof(k,dhour+1)
-                 IF ( aheat(k,j,i) > 0.0_wp )  THEN
-                    pt(k,j,i) = pt(k,j,i) + aheat(k,j,i)*acoef*dt_3d/(exner(k)*rho_cp*dzu(k))
-                 ENDIF
-              ENDIF
+           DO i = nxl, nxr
+              DO j = nys, nyn
+                 DO k = nzub, min(nzut,naheatlayers)
+                    IF ( k > get_topography_top_index_ji( j, i, 's' ) ) THEN
+!--                    increase of pt in box i,j,k in time dt_3d 
+!--                    given to anthropogenic heat aheat*acoef (W*m-2)
+!--                    linear interpolation of coeficient
+                       acoef = (REAL(dhour+1,wp)-dtime/3600.0_wp)*aheatprof(k,dhour) + &
+                               (dtime/3600.0_wp-REAL(dhour,wp))*aheatprof(k,dhour+1)
+                       IF ( aheat(k,j,i) > 0.0_wp )  THEN
+!--                       calculate rho * c_p coefficient at layer k
+                          rho_cp  = c_p * hyp(k) / ( r_d * pt(k+1,j,i) * exner(k) )
+                          pt(k,j,i) = pt(k,j,i) + aheat(k,j,i)*acoef*dt_3d/(exner(k)*rho_cp*dz(1))
+                       ENDIF
+                    ENDIF
+                 ENDDO
+              ENDDO
            ENDDO
 
